diff -Naur glibc-2.3.3-pristine/csu/Makefile glibc-2.3.3/csu/Makefile
--- glibc-2.3.3-pristine/csu/Makefile	2003-09-25 13:29:39.000000000 -0700
+++ glibc-2.3.3/csu/Makefile	2004-12-05 21:30:42.400897070 -0800
@@ -104,7 +104,7 @@
 $(crtstuff:%=$(objpfx)%.o): %.o: %.S $(objpfx)defs.h
 	$(compile.S) -g0 $(ASFLAGS-.os) -o $@
 
-CFLAGS-initfini.s = -g0 -fPIC -fno-inline-functions
+CFLAGS-initfini.s = -O1 -g0 -fPIC -fno-inline-functions
 
 vpath initfini.c $(full_config_sysdirs)
 
diff -Naur glibc-2.3.3-pristine/Makeconfig glibc-2.3.3/Makeconfig
--- glibc-2.3.3-pristine/Makeconfig	2003-09-17 01:36:10.000000000 -0700
+++ glibc-2.3.3/Makeconfig	2004-12-05 21:29:51.801354350 -0800
@@ -511,7 +511,7 @@
 link-extra-libs-bounded = $(foreach lib,$(LDLIBS-$(@F:%-bp=%)),$(common-objpfx)$(lib)_b.a)
 
 ifndef gnulib
-gnulib := -lgcc -lgcc_eh
+gnulib := -lgcc  # -lgcc_eh
 endif
 ifeq ($(elf),yes)
 +preinit = $(addprefix $(csu-objpfx),crti.o)
diff -Naur glibc-2.3.3-pristine/sysdeps/arm/framestate.c glibc-2.3.3/sysdeps/arm/framestate.c
--- glibc-2.3.3-pristine/sysdeps/arm/framestate.c	1969-12-31 16:00:00.000000000 -0800
+++ glibc-2.3.3/sysdeps/arm/framestate.c	2004-12-05 21:29:51.802354242 -0800
@@ -0,0 +1 @@
+/* empty file */
diff -Naur glibc-2.3.3-pristine/sysdeps/arm/machine-gmon.h glibc-2.3.3/sysdeps/arm/machine-gmon.h
--- glibc-2.3.3-pristine/sysdeps/arm/machine-gmon.h	2001-07-05 21:55:48.000000000 -0700
+++ glibc-2.3.3/sysdeps/arm/machine-gmon.h	2004-12-05 21:29:51.816352733 -0800
@@ -32,10 +32,8 @@
 weak_alias (_mcount, mcount)
 #endif
 
-static void mcount_internal (u_long frompc, u_long selfpc);
-
 #define _MCOUNT_DECL(frompc, selfpc) \
-static void mcount_internal (u_long frompc, u_long selfpc)
+void mcount_internal (u_long frompc, u_long selfpc)
 
 /* This macro/func MUST save r0, r1 because the compiler inserts
 	blind calls to _mount(), ignoring the fact that _mcount may
diff -Naur glibc-2.3.3-pristine/sysdeps/unix/sysv/linux/arm/ioperm.c glibc-2.3.3/sysdeps/unix/sysv/linux/arm/ioperm.c
--- glibc-2.3.3-pristine/sysdeps/unix/sysv/linux/arm/ioperm.c	2003-02-20 14:22:35.000000000 -0800
+++ glibc-2.3.3/sysdeps/unix/sysv/linux/arm/ioperm.c	2004-12-05 21:29:51.817352625 -0800
@@ -47,6 +47,12 @@
 #include <asm/page.h>
 #include <sys/sysctl.h>
 
+/* see http://www.ussg.iu.edu/hypermail/linux/kernel/0311.0/0529.html */
+#include <linux/version.h>
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,4,23))
+#define CTL_BUS_ISA BUS_ISA    /* and hope it's not the one from linux/input.h */
+#endif
+
 #define PATH_ARM_SYSTYPE	"/etc/arm_systype"
 #define PATH_CPUINFO		"/proc/cpuinfo"
 
@@ -80,7 +86,7 @@
  * Initialize I/O system.  There are several ways to get the information
  * we need.  Each is tried in turn until one succeeds.
  *
- * 1. Sysctl (CTL_BUS, BUS_ISA, ISA_*).  This is the preferred method
+ * 1. Sysctl (CTL_BUS, CTL_BUS_ISA, ISA_*).  This is the preferred method
  *    but not all kernels support it.
  *
  * 2. Read the value (not the contents) of symlink PATH_ARM_SYSTYPE.
@@ -100,8 +106,8 @@
 {
   char systype[256];
   int i, n;
-  static int iobase_name[] = { CTL_BUS, BUS_ISA, BUS_ISA_PORT_BASE };
-  static int ioshift_name[] = { CTL_BUS, BUS_ISA, BUS_ISA_PORT_SHIFT };
+  static int iobase_name[] = { CTL_BUS, CTL_BUS_ISA, BUS_ISA_PORT_BASE };
+  static int ioshift_name[] = { CTL_BUS, CTL_BUS_ISA, BUS_ISA_PORT_SHIFT };
   size_t len = sizeof(io.base);
 
   if (! sysctl (iobase_name, 3, &io.io_base, &len, NULL, 0)
